#include "hal_base.h"
#include "hal_gpio.h"
#include "hal_uart.h"
#include "hal_irq.h"


uint8_t recv_data;	// յֵ
uint8_t send_data;	// ͵ֵ

/* ʼPB4 TX, PB5 RX */
void GPIO_init(void)
{
	gpio_init_t init;
	init.io = GPIO_OUTPUT;
	init.level = GPIO_LOW_LEVEL;
	init.mode = GPIO_DIGIT_MODE;
	init.pu = DISABLE;
	init.pd = DISABLE;
	init.drive = GPIO_LOW_DRIVER;
	init.od = DISABLE;
	init.smit = GPIO_1_5_TO_3_0_SMIT;
	init.cur_ctr = DISABLE;
	gpio_init(PB_TYPE, GPIO_PIN_4, &init);

	init.io = GPIO_INPUT;
	gpio_init(PB_TYPE, GPIO_PIN_5, &init);
}


/* жϷʹжϣINVT = 00UART RXTXIG5УжڵַΪ0x001c
   ΪRXжϣжϱ־ݣΪTXжϣжϱ־ */
void isr_uart(void) interrupt_low 0x001c
{
	if (irq_get_it_status(TX0IE_IT) && irq_get_flag_status(TX0IE_IT)) {
		irq_clear_flag_status(TX0IE_IT);
		uart_tx(&send_data);
	}

	if (irq_get_it_status(RX0IE_IT) && irq_get_flag_status(RX0IE_IT)) {
		irq_clear_flag_status(RX0IE_IT);
		recv_data = uart_rx();
	}
}

void main() 
{
	// RAMʼ
	ram_clear();
	// clockʼѡHRC,Ƶʹclock 
	clock_init(CLOCK_SRC_HRC, CLOCK_DIV_1, DISABLE);
	// GPIOڳʼ
	GPIO_init();

	// ͵ֵΪ0x55
	send_data = 0x55;
	// uartʼΪ115200
	uart_init(115200);

	// ѡжģʽ
	INTVEN0 = 1;
	// ʹܵȼж
	GIEL    = 1;
	// ʹж
	IRQ_GIE_CFG(1);
	// ʹTXж
	irq_config(TX0IE_IT, ENABLE);
	// ʹRXж
	irq_config(RX0IE_IT, ENABLE);

	while (1) {
		// ι
		CLRWDT();
	}
}